
#    Note:  This is loaded into the namespace LOCK

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable Line_count 0

    variable JS ""

    variable allmodules 0
    variable module_list ""
      set BAK $::AIDA::FEE64   ;#   save
	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item	
    		variable Name$item "$item"
		foreach fadc { 0 1 2 3 4 5 6 7 } {
     		
			variable Error[set item]ADC$fadc 0
      			variable Error[set item]Diff$fadc 0
 			variable ErrorOld[set item]Diff$fadc [ ReadAIDARegister [ expr 0xB11 + $fadc * 2 ]  ]
			
			variable Frame[set item]ADC$fadc 0
		}
  
	}

      set ::AIDA::FEE64 $BAK   ;#   restore

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }


   proc do_redisplay {} {

     variable module_list
     variable allmodules 

      set BAK $::AIDA::FEE64   ;#   save

	foreach item $::AIDA::ModuleMenu {
 		set ::AIDA::FEE64 $item		
		foreach fadc { 0 1 2 3 4 5 6 7 } { ; # declare the variables to be used
     		
			variable Error[set item]ADC$fadc 
      			variable Error[set item]Diff$fadc
 			variable ErrorOld[set item]Diff$fadc 
			variable Frame[set item]ADC$fadc 
		}
  
		foreach fadc { 0 1 2 3 4 5 6 7 } {
			set frame  [ ReadAIDARegister [ expr 0xB10 + $fadc * 2 ]  ]
			if { $frame == 0x3f80 } {
				set Frame[set item]ADC$fadc "<font color=green>$frame<\/font>"
			} else {
				set Frame[set item]ADC$fadc "<font color=red>$frame<\/font>"
			}

			set vl0 [ set ErrorOld[set item]Diff$fadc ]
			set vl1 [ ReadAIDARegister [ expr 0xB11 + $fadc * 2 ]  ]
     			set Error[set item]Diff$fadc [ expr $vl1 - $vl0 ]
			if { $vl0 == $vl1 } {
				set Error[set item]ADC$fadc "<font color=green>$vl0<\/font>"
			} else {
				set Error[set item]ADC$fadc "<font color=red>$vl1<\/font>"
				set ErrorOld[set item]Diff$fadc $vl1
			}
 		}
 
	}
      set ::AIDA::FEE64 $BAK   ;#    restore


   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules
      variable module_list

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




